lzma_mf_s Struct Reference

## Data Fields

uint8_t * | buffer
| Pointer to buffer with data to be compressed. More...
uint32_t | size
uint32_t | keep_size_before
uint32_t | keep_size_after
uint32_t | offset
uint32_t | read_pos
uint32_t | read_ahead
uint32_t | read_limit
uint32_t | write_pos
uint32_t | pending
uint32_t(* | find )(lzma_mf *mf, lzma_match *matches)
void(* | skip )(lzma_mf *mf, uint32_t num)
uint32_t * | hash
uint32_t * | son
uint32_t | cyclic_pos
uint32_t | cyclic_size
uint32_t | hash_mask
uint32_t | depth
| Maximum number of loops in the match finder. More...
uint32_t | nice_len
| Maximum length of a match that the match finder will try to find. More...
uint32_t | match_len_max
lzma_action | action
uint32_t | hash_count
| Number of elements in hash[]. More...
uint32_t | sons_count
| Number of elements in son[]. More...

## Field Documentation

## buffer

uint8_t* lzma_mf_s::buffer

Pointer to buffer with data to be compressed.

Referenced by mf_ptr().

## size

uint32_t lzma_mf_s::size

Total size of the allocated buffer (that is, including all the extra space)

## keep_size_before

uint32_t lzma_mf_s::keep_size_before

Number of bytes that must be kept available in our input history. That is, once keep_size_before bytes have been processed, buffer[read_pos - keep_size_before] is the oldest byte that must be available for reading.

## keep_size_after

uint32_t lzma_mf_s::keep_size_after

Number of bytes that must be kept in buffer after read_pos. That is, read_pos <= write_pos - keep_size_after as long as action is LZMA_RUN; when action != LZMA_RUN, read_pos is allowed to reach write_pos so that the last bytes get encoded too.

## offset

uint32_t lzma_mf_s::offset

Match finders store locations of matches using 32-bit integers. To avoid adjusting several megabytes of integers every time the input window is moved with move_window, we only adjust the offset of the buffer. Thus, buffer[value_in_hash_table - offset] is the byte pointed by value_in_hash_table.

## read_pos

uint32_t lzma_mf_s::read_pos

buffer[read_pos] is the next byte to run through the match finder. This is incremented in the match finder once the byte has been processed.

Referenced by mf_avail(), mf_position(), mf_ptr(), mf_unencoded(), move_pending(), and move_pos().

## read_ahead

uint32_t lzma_mf_s::read_ahead

Number of bytes that have been ran through the match finder, but which haven't been encoded by the LZ-based encoder yet.

Referenced by mf_position(), mf_skip(), and mf_unencoded().

## read_limit

uint32_t lzma_mf_s::read_limit

As long as read_pos is less than read_limit, there is enough input available in buffer for at least one encoding loop.

Because of the stateful API, read_limit may and will get greater than read_pos quite often. This is taken into account when calculating the value for keep_size_after.

## write_pos

uint32_t lzma_mf_s::write_pos

buffer[write_pos] is the first byte that doesn't contain valid uncompressed data; that is, the next input byte will be copied to buffer[write_pos].

Referenced by mf_avail(), and mf_unencoded().

## pending

uint32_t lzma_mf_s::pending

Number of bytes not hashed before read_pos. This is needed to restart the match finder after LZMA_SYNC_FLUSH.

## find

uint32_t(* lzma_mf_s::find) (lzma_mf *mf, lzma_match *matches)

Find matches. Returns the number of distance-length pairs written to the matches array. This is called only via lzma_mf_find().

Referenced by lzma_mf_find().

## skip

void(* lzma_mf_s::skip) (lzma_mf *mf, uint32_t num)

Skips num bytes. This is like find() but doesn't make the distance-length pairs available, thus being a little faster. This is called only via mf_skip().

Referenced by mf_skip().

## depth

uint32_t lzma_mf_s::depth

Maximum number of loops in the match finder.

## nice_len

uint32_t lzma_mf_s::nice_len

Maximum length of a match that the match finder will try to find.

## match_len_max

uint32_t lzma_mf_s::match_len_max

Maximum length of a match supported by the LZ-based encoder. If the longest match found by the match finder is nice_len, mf_find() tries to expand it up to match_len_max bytes.

## action

lzma_action lzma_mf_s::action

When running out of input, binary tree match finders need to know if it is due to flushing or finishing. The action is used also by the LZ-based encoders themselves.

## hash_count

uint32_t lzma_mf_s::hash_count

Number of elements in hash[].

## sons_count

uint32_t lzma_mf_s::sons_count

Number of elements in son[].

The documentation for this struct was generated from the following file:

- liblzma/lz/lz_encoder.h